#INCLUDE "Main.h"

*************************************************************
* Procedura, kter vrt objekt pro pakovn a rozpakovn
PROCEDURE CVP_GetInterface(loObj)
*@loObj - Vlastnost do kter se zape odkaz na objekt pro pakovn
loObj=CREATEOBJECT("_bix_Archiver")


*************************************************************
* vlastn tda pro pakovn a rozpakovn
DEFINE CLASS _bix_Archiver AS Custom
   Name="_bix_Archiver"
  
   * Dekompresn metoda
   PROCEDURE Decompress(loPack)
      * loPack - Objekt pro rozpakovn
      LOCAL lcDir,lcProgram,lctmpFile,lcUnpackPath,liz,lcStartupInfo,lcProcessInfo,liRet,liWFS,lcPom
      LOCAL ARRAY laDir(1)
      
      lctmpFile=loPack.File_S
      lcDir=ExtractPathFromFile(lctmpFile) + CHR(0)
      lcUnpackPath=GetTempPathEx()+SYS(2015)+"\" && pracovn nzev cesty
      =MKD(lcUnpackPath) && vytvo pracovn cestu

      * vytvo C++ strukturu z VFP objektu
      lcStartupInfo=loPack.SI.CreateString()
      lcProcessInfo=loPack.PI.CreateString()

      lcProgram = loPack.PU.D_File+" e "+lctmpFile+" -o"+lcUnpackPath+" -y" + CHR(0)
      =SetLastError(0)
      liRet=_PP_ProcessFailed
      lcPom=.NULL.
      IF CreateProcess(@lcPom, @lcProgram, 0, 0, 1,  NORMAL_PRIORITY_CLASS, 0, @lcDir, @lcStartupInfo, @lcProcessInfo)#0
         * vborn neselhalo to
         loPack.PI.ReadString(@lcProcessInfo)
         liWFS=WAIT_TIMEOUT
         DO WHILE liWFS= WAIT_TIMEOUT
            liWFS=WaitForSingleObject(loPack.PI.hProcess, 250 )
         ENDDO
         =CloseHandle(loPack.PI.hProcess) && uzavi handle
         liz=ADIR(laDir,lcUnpackPath+"*.*","ASRH") && nati vechny soubory

         liRet=IIF(liz=0,_PP_PAUNFailed,;
               IIF(MoveFile((lcUnpackPath+laDir(1,1)+CHR(0)),(loPack.File_D+CHR(0)))=1,_PP_ErrOK,_PP_PAUNFailed))

      ENDIF
      =RemoveDirectoryAll(lcUnpackPath) && zlikviduj pracovn cestu
      RETURN liRet
   ENDPROC

   * Kompresn metoda
   PROCEDURE Compress(loPack)
      * loPack - Objekt pro rozpakovn

      LOCAL lcDir,lcProgram,lcStartupInfo,lcProcessInfo,liRet,liExitCode,lcPom

      lcDir=ExtractPathFromFile(loPack.File_S) + CHR(0)
      lcProgram = loPack.PU.C_File+" a "+loPack.File_D+" "+ExtractFileFromFile(loPack.File_S) + CHR(0)

      lcStartupInfo=loPack.SI.CreateString()
      lcProcessInfo=loPack.PI.CreateString()

      =SetLastError(0)
      liRet=_PP_ProcessFailed
      lcPom=.NULL.
      IF CreateProcess(@lcPom, @lcProgram, 0, 0, 1, NORMAL_PRIORITY_CLASS, 0, @lcDir, @lcStartupInfo, @lcProcessInfo)#0
         * vborn neselhalo to
         loPack.PI.ReadString(@lcProcessInfo)

         liExitCode=STILL_ACTIVE
         DO WHILE liExitCode=STILL_ACTIVE
            =Sleep(500)
            =GetExitCodeProcess(loPack.PI.hProcess,@liExitCode )
         ENDDO

         =CloseHandle(loPack.PI.hProcess) && uzavi handle
         liRet=_PP_ErrOK
      ENDIF
      RETURN liRet
   ENDPROC
ENDDEFIN